## rr 5.6.0

=== CMakeLists.txt ===
# *-* Mode: cmake; *-*

cmake_minimum_required(VERSION 3.1.0)
project(rr C CXX ASM)

# "Do not add flags to export symbols from executables without the ENABLE_EXPORTS target property."
# This avoids linking executables with -rdynamic. -rdynamic has been observed
# to cause rr_exec_stub to be linked with the dynamic linker with some
# version(s) of clang (but linked to an incorrect file name, causing
# exec of rr_exec_stub to fail).
if(POLICY CMP0065)
  cmake_policy(SET CMP0065 NEW)
endif()

# On single configuration generators, make Debug the default configuration
if(NOT CMAKE_CONFIGURATION_TYPES)
  if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "Debug" CACHE STRING "Whether to build in `Debug` or `Release` mode." FORCE)
  endif()
endif()

enable_testing()
set(BUILD_SHARED_LIBS ON)

set(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib/rr)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

set(BUILD_TESTS ON CACHE BOOL "Build tests")
set(WILL_RUN_TESTS ${BUILD_TESTS} CACHE BOOL "Run tests")
option(INSTALL_TESTSUITE "Install the testsuite")

# CAREFUL!  "-" is an invalid character in RPM package names, while
# debian is happy with it.  However, "_" is illegal in debs, while RPM
# is cool with it.  Sigh.
set(rr_VERSION_MAJOR 5)
set(rr_VERSION_MINOR 6)
set(rr_VERSION_PATCH 0)

add_definitions(-DRR_VERSION="${rr_VERSION_MAJOR}.${rr_VERSION_MINOR}.${rr_VERSION_PATCH}")

execute_process(
  COMMAND git rev-parse HEAD
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  OUTPUT_VARIABLE GIT_REVISION
  OUTPUT_STRIP_TRAILING_WHITESPACE
)
configure_file(
  ${CMAKE_SOURCE_DIR}/src/git_revision.h.in
  ${CMAKE_BINARY_DIR}/git_revision.h
)

set(FLAGS_COMMON "-D__USE_LARGEFILE64 -pthread")
set(supports32bit true)
set(x86ish false)
set(has_syscallbuf false)
if (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "aarch64")
  set(has_syscallbuf true)
  set(supports32bit false)
  set(FLAGS_COMMON "${FLAGS_COMMON} -march=armv8.3-a -moutline-atomics")
  set(PRELOAD_LIBRARY_PAGE_SIZE 65536)
  set(VDSO_NAME "LINUX_2.6.39")
else()
  set(x86ish true)
  set(has_syscallbuf true)
  set(FLAGS_COMMON "${FLAGS_COMMON} -msse2 -D__MMX__ -D__SSE__ -D__SSE2__")
  set(PRELOAD_LIBRARY_PAGE_SIZE 4096)
  set(VDSO_NAME "LINUX_2.6")
endif()
configure_file(src/preload/rr_page.ld.in src/preload/rr_page.ld @ONLY)

include(CheckCCompilerFlag)
CHECK_C_COMPILER_FLAG("-fmacro-prefix-map=foo=bar" SUPPORTS_MACRO_PREFIX_MAP)
if (SUPPORTS_MACRO_PREFIX_MAP)
  set(FLAGS_COMMON "${FLAGS_COMMON} -fmacro-prefix-map=${CMAKE_SOURCE_DIR}/=")
endif()

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${FLAGS_COMMON} -Wstrict-prototypes -std=gnu11")
# Define __STDC_LIMIT_MACROS so |#include <stdint.h>| works as expected.
# Define __STDC_FORMAT_MACROS so |#include <inttypes.h>| works as expected.
include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG("-std=c++14" SUPPORTS_CXX14)
if (SUPPORTS_CXX14)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${FLAGS_COMMON} -D__STDC_LIMIT_MACROS -D__STDC_FORMAT_MACROS -std=c++14")
else()
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${FLAGS_COMMON} -D__STDC_LIMIT_MACROS -D__STDC_FORMAT_MACROS -std=c++11")
endif()

# We support three build types:
# DEBUG: suitable for debugging rr
# RELEASE: suitable for using rr in production (but keeps rr debuginfo)
# OTHER: suitable for using rr in production, but honouring distro/user opt/debug settings
# (which we assume are suitable for production use)

# Base settings for debug and release/unspecified builds.
# Use -Werror for debug builds because we assume a developer is building, not a user.
set(RR_FLAGS_DEBUG "-Wall -Wextra -DDEBUG -UNDEBUG")
set(RR_FLAGS_RELEASE "-Wall -Wextra -UDEBUG -DNDEBUG")

# The folowing settings are the defaults for the OTHER build type.
# Flags used to build the preload library. MUST have debuginfo enabled. SHOULD be optimized.
set(PRELOAD_COMPILE_FLAGS "${RR_FLAGS_RELEASE} -fno-stack-protector -g3 -U_FORTIFY_SOURCE")
# Flags used to build Brotli. SHOULD be optimized. MUST NOT error on warnings.
set(BROTLI_COMPILE_FLAGS ${RR_FLAGS_RELEASE})
# Flags used to build tests. MUST have -DDEBUG and debuginfo enabled, MUST NOT be optimized.
set(RR_TEST_FLAGS "${RR_FLAGS_DEBUG} -g3 -O0")
# Flags used to build other files. Entirely build-type-dependent.
set(RR_FLAGS ${RR_FLAGS_RELEASE})

# Now override for build type.
string(TOLOWER ${CMAKE_BUILD_TYPE} LOWERCASE_CMAKE_BUILD_TYPE)
if(LOWERCASE_CMAKE_BUILD_TYPE STREQUAL "debug")
  set(PRELOAD_COMPILE_FLAGS "${PRELOAD_COMPILE_FLAGS} -O2 -Werror")
  set(BROTLI_COMPILE_FLAGS "${RR_FLAGS_RELEASE} -O2")
  set(RR_TEST_FLAGS "${RR_TEST_FLAGS} -Werror")
  set(RR_FLAGS "${RR_FLAGS_DEBUG} -g3 -Werror")
elseif(LOWERCASE_CMAKE_BUILD_TYPE STREQUAL "release")
  # CMake itself will add optimization flags
  set(RR_FLAGS "${RR_FLAGS_RELEASE} -g3 -flto")
endif()

set(LINKER_FLAGS "")
if(CMAKE_C_COMPILER_ID STREQUAL "GNU")
  # Gcc generates bogus R_386_GOTOFF relocations in .debug_info which
  # lld 9 rejects
  set(LINKER_FLAGS "-fuse-ld=bfd")
endif()

if(CMAKE_C_COMPILER_ID STREQUAL "Clang")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unused-command-line-argument")
endif()
if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-command-line-argument")
endif()
if (CMAKE_ASM_COMPILER_ID STREQUAL "Clang")
  set(CMAKE_ASM_FLAGS "${CMAKE_ASM_FLAGS} -fno-integrated-as")
endif()

option(force32bit "Force a 32-bit rr build, rather than both 64 and 32-bit. rr will only be able to record and replay 32-bit processes.")
option(disable32bit "On a 64-bit platform, avoid requiring a 32-bit cross-compilation toolchain by not building 32-bit components. rr will be able to record 32-bit processes but not replay them.")

if(force32bit)
  set(rr_32BIT true)
  set(rr_64BIT false)
  set(rr_MBITNESS_OPTION -m32)
else()
  if(CMAKE_SIZEOF_VOID_P EQUAL 8)
    if(disable32bit OR NOT supports32bit)
      set(rr_32BIT false)
    else()
      set(rr_32BIT true)
    endif()
    set(rr_64BIT true)
  else()
    set(rr_32BIT true)
    set(rr_64BIT false)
  endif()
  set(rr_MBITNESS_OPTION)
endif()

option(staticlibs "Force usage of static linkage for non-standard libraries like capnproto")

# Check that compiling 32-bit code on a 64-bit target works, if required.
if(CMAKE_HOST_SYSTEM_PROCESSOR STREQUAL "x86_64" AND rr_32BIT)
  # try_compile won't accept LINK_FLAGS, so do this manually.
  file(WRITE "${CMAKE_BINARY_DIR}/test32.c" "int main() { return 0; }")
  execute_process(COMMAND ${CMAKE_C_COMPILER} -o ${CMAKE_BINARY_DIR}/test32 ${CMAKE_BINARY_DIR}/test32.c -m32
                  RESULT_VARIABLE COMPILER_32BIT_RESULT)
  if(NOT (COMPILER_32BIT_RESULT EQUAL 0))
    message(FATAL_ERROR "Your toolchain doesn't support 32-bit cross-compilation. Install the required packages or pass -Ddisable32bit=ON to cmake.")
  endif()
endif()

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${rr_MBITNESS_OPTION}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${rr_MBITNESS_OPTION}")
set(CMAKE_ASM_FLAGS "${CMAKE_ASM_FLAGS} ${rr_MBITNESS_OPTION}")

# If SKIP_PKGCONFIG is set then ${PKG}_CFLAGS and ${PKG}_LDFLAGS must be
# provided as well.
if(NOT SKIP_PKGCONFIG)
  find_package(PkgConfig REQUIRED)

  # If we're cross-compiling a 32-bit rr build on a 64-bit host we need
  # to ensure we're looking for the right libraries.
  # This has been tested on Ubuntu and Fedora.
  if(CMAKE_HOST_SYSTEM_PROCESSOR STREQUAL "x86_64" AND NOT rr_64BIT)
    set(LIBDIR32_CANDIDATES
      /usr/lib/i386-linux-gnu/pkgconfig/
      /usr/lib/pkgconfig/
    )
    foreach(libdir ${LIBDIR32_CANDIDATES})
      if(IS_DIRECTORY ${libdir})
        set(ENV{PKG_CONFIG_LIBDIR} ${libdir})
        break()
      endif()
    endforeach(libdir)
    if(NOT DEFINED ENV{PKG_CONFIG_LIBDIR})
      message(FATAL_ERROR "Couldn't find a suitable 32-bit pkgconfig lib dir. You probably need to install a 32-bit pkgconfig package (pkgconfig.i686 for Fedora or pkg-config:i386 for Ubuntu")
    endif()
  endif()
endif()

find_program(CAPNP capnp)
if(${CAPNP} STREQUAL "CAPNP-NOTFOUND")
  message(FATAL_ERROR "Can't find 'capnp' command; install Capnproto packages? https://github.com/rr-debugger/rr/wiki/Building-And-Installing#tldr")
endif()

set(REQUIRED_LIBS
  capnp
# zlib is required to handle ELF compression
  zlib
)

foreach(required_lib ${REQUIRED_LIBS})
  string(TOUPPER ${required_lib} PKG)
  if(NOT SKIP_PKGCONFIG)
    pkg_check_modules(${PKG} REQUIRED ${required_lib})
  endif()
  if(staticlibs)
    string(REPLACE ";" " " ${PKG}_STATIC_CFLAGS "${${PKG}_STATIC_CFLAGS}")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${${PKG}_STATIC_CFLAGS}")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${${PKG}_STATIC_CFLAGS}")
  else()
    string(REPLACE ";" " " ${PKG}_CFLAGS "${${PKG}_CFLAGS}")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${${PKG}_CFLAGS}")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${${PKG}_CFLAGS}")
  endif()
endforeach(required_lib)

# ==== brotli ====
set(BROTLI_FILES
  third-party/brotli/common/dictionary.c
  third-party/brotli/common/transform.c
  third-party/brotli/dec/bit_reader.c
  third-party/brotli/dec/decode.c
  third-party/brotli/dec/huffman.c
  third-party/brotli/dec/state.c
  third-party/brotli/enc/backward_references.c
  third-party/brotli/enc/backward_references.h
  third-party/brotli/enc/backward_references_hq.c
  third-party/brotli/enc/backward_references_hq.h
  third-party/brotli/enc/backward_references_inc.h
  third-party/brotli/enc/bit_cost.c
  third-party/brotli/enc/bit_cost.h
  third-party/brotli/enc/bit_cost_inc.h
  third-party/brotli/enc/block_encoder_inc.h
  third-party/brotli/enc/block_splitter.c
  third-party/brotli/enc/block_splitter.h
  third-party/brotli/enc/block_splitter_inc.h
  third-party/brotli/enc/brotli_bit_stream.c
  third-party/brotli/enc/brotli_bit_stream.h
  third-party/brotli/enc/cluster.c
  third-party/brotli/enc/cluster.h
  third-party/brotli/enc/cluster_inc.h
  third-party/brotli/enc/command.h
  third-party/brotli/enc/compress_fragment.c
  third-party/brotli/enc/compress_fragment.h
  third-party/brotli/enc/compress_fragment_two_pass.c
  third-party/brotli/enc/compress_fragment_two_pass.h
  third-party/brotli/enc/context.h
  third-party/brotli/enc/dictionary_hash.c
  third-party/brotli/enc/dictionary_hash.h
  third-party/brotli/enc/encode.c
  third-party/brotli/enc/encoder_dict.c
  third-party/brotli/enc/entropy_encode.c
  third-party/brotli/enc/entropy_encode.h
  third-party/brotli/enc/entropy_encode_static.h
  third-party/brotli/enc/fast_log.h
  third-party/brotli/enc/find_match_length.h
  third-party/brotli/enc/hash_forgetful_chain_inc.h
  third-party/brotli/enc/hash.h
  third-party/brotli/enc/hash_longest_match64_inc.h
  third-party/brotli/enc/hash_longest_match_inc.h
  third-party/brotli/enc/hash_longest_match_quickly_inc.h
  third-party/brotli/enc/hash_to_binary_tree_inc.h
  third-party/brotli/enc/histogram.c
  third-party/brotli/enc/histogram.h
  third-party/brotli/enc/histogram_inc.h
  third-party/brotli/enc/literal_cost.c
  third-party/brotli/enc/literal_cost.h
  third-party/brotli/enc/memory.c
  third-party/brotli/enc/memory.h
  third-party/brotli/enc/metablock.c
  third-party/brotli/enc/metablock.h
  third-party/brotli/enc/metablock_inc.h
  third-party/brotli/enc/port.h
  third-party/brotli/enc/prefix.h
  third-party/brotli/enc/quality.h
  third-party/brotli/enc/ringbuffer.h
  third-party/brotli/enc/static_dict.c
  third-party/brotli/enc/static_dict.h
  third-party/brotli/enc/static_dict_lut.h
  third-party/brotli/enc/utf8_util.c
  third-party/brotli/enc/utf8_util.h
  third-party/brotli/enc/write_bits.h
)
add_library(brotli STATIC ${BROTLI_FILES})
set_source_files_properties(${BROTLI_FILES}
                            PROPERTIES COMPILE_FLAGS ${BROTLI_COMPILE_FLAGS})
# ==== brotli ====

find_library(LIBRT rt)

find_path(SECCOMP NAMES "linux/seccomp.h")
if(NOT SECCOMP)
  message(FATAL_ERROR "Couldn't find linux/seccomp.h. You may need to upgrade your kernel.")
endif()

find_path(EXECINFO_H NAMES "execinfo.h")
if(EXECINFO_H)

=== debian/changelog ===
rr (5.6.0-4ubuntu0.1) mantic; urgency=medium

  * debian/patches: Add support for AMD Phoenix Zen 4 CPU (LP: #2065141)

 -- Marco Trevisan (Treviño) <marco@ubuntu.com>  Wed, 08 May 2024 09:02:10 +0200

rr (5.6.0-4) unstable; urgency=medium

  * Apply upstream patch to add missing cstdint includes, allowing
    building with GCC 13. Closes: #1037848.
  * Standards-Version 4.6.2, no change required.
  * Pass C flags to the assembler, to avoid storing absolute paths in
    files produced by the assembler. Thanks to Bernhard Übelacker for
    the patch! Closes: #973894.

 -- Stephen Kitt <skitt@debian.org>  Sun, 25 Jun 2023 18:10:44 +0200

rr (5.6.0-3) unstable; urgency=medium

  * Apply upstream patch to avoid building a struct embedding a flexible-
    length array from ethtool_sset_info. Closes: #1022316.
  * Update debian/copyright to cover proc_service.h.

 -- Stephen Kitt <skitt@debian.org>  Sun, 23 Oct 2022 17:25:02 +0200

rr (5.6.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Stephen Kitt <skitt@debian.org>  Mon, 15 Aug 2022 18:01:09 +0200

rr (5.6.0-2~exp1) experimental; urgency=medium

  * Enable building on arm64.

 -- Stephen Kitt <skitt@debian.org>  Mon, 15 Aug 2022 10:49:43 +0200

rr (5.6.0-1) unstable; urgency=medium

  [ Stephen Kitt ]
  * New upstream release.
  * Update lintian overrides for lintian 2.115.0.
  * Standards-Version 4.6.1, no further change required.

  [ Debian Janitor ]
  * Use secure URI in Homepage field.

 -- Stephen Kitt <skitt@debian.org>  Sun, 14 Aug 2022 14:53:38 +0200

=== debian/control ===
Source: rr
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Stephen Kitt <skitt@debian.org>
Section: devel
Priority: optional
Build-Depends: capnproto,
               cmake,
               debhelper-compat (= 13),
               dh-python,
               g++-multilib [amd64],
               gdb,
               libcapnp-dev,
               libdisasm-dev,
               libpfm4-dev,
               pkg-config,
               python3,
               python3-pexpect,
               zlib1g-dev,
# The following are required for the test suite
# realpath
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/debian/rr
Vcs-Git: https://salsa.debian.org/debian/rr.git
Homepage: https://rr-project.org
Rules-Requires-Root: no

Package: rr
Architecture: amd64 arm64 i386
Depends: ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends},
         sse2-support [i386]
Description: application execution recorder, player and debugger
 rr allows application executions to be recorded and then replayed
 with gdb as many times as desired.
 .
 This allows intermittent, or complex to reproduce, bugs to be
 captured and then debugged at leisure. Replays are deterministic,
 always identical from one run to another.
 .
 rr is incompatible with ptrace hardening, and currently only supports
 Intel CPUs with Nehalem or later microarchitectures, some AMD CPUs
 with Zen or later microarchitectures, and some AArch64
 microarchitectures (e.g. ARM Neoverse N1 or Apple Silicon M-series).
 The amd64 package supports debugging amd64 and i386 binaries.

## rr 5.7.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # *-* Mode: cmake; *-*
 
-cmake_minimum_required(VERSION 3.1.0)
+cmake_minimum_required(VERSION 3.5)
 project(rr C CXX ASM)
 
 # "Do not add flags to export symbols from executables without the ENABLE_EXPORTS target property."
@@ -34,8 +34,12 @@
 # debian is happy with it.  However, "_" is illegal in debs, while RPM
 # is cool with it.  Sigh.
 set(rr_VERSION_MAJOR 5)
-set(rr_VERSION_MINOR 6)
+set(rr_VERSION_MINOR 7)
 set(rr_VERSION_PATCH 0)
+
+if(ANDROID)
+  find_package(CapnProto REQUIRED)
+endif()
 
 add_definitions(-DRR_VERSION="${rr_VERSION_MAJOR}.${rr_VERSION_MINOR}.${rr_VERSION_PATCH}")
 
@@ -48,6 +52,10 @@
 configure_file(
   ${CMAKE_SOURCE_DIR}/src/git_revision.h.in
   ${CMAKE_BINARY_DIR}/git_revision.h
+)
+configure_file(
+  ${CMAKE_SOURCE_DIR}/src/extra_version_string.h.in
+  ${CMAKE_BINARY_DIR}/extra_version_string.h
 )
 
 set(FLAGS_COMMON "-D__USE_LARGEFILE64 -pthread")
@@ -78,13 +86,7 @@
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${FLAGS_COMMON} -Wstrict-prototypes -std=gnu11")
 # Define __STDC_LIMIT_MACROS so |#include <stdint.h>| works as expected.
 # Define __STDC_FORMAT_MACROS so |#include <inttypes.h>| works as expected.
-include(CheckCXXCompilerFlag)
-CHECK_CXX_COMPILER_FLAG("-std=c++14" SUPPORTS_CXX14)
-if (SUPPORTS_CXX14)
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${FLAGS_COMMON} -D__STDC_LIMIT_MACROS -D__STDC_FORMAT_MACROS -std=c++14")
-else()
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${FLAGS_COMMON} -D__STDC_LIMIT_MACROS -D__STDC_FORMAT_MACROS -std=c++11")
-endif()
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${FLAGS_COMMON} -D__STDC_LIMIT_MACROS -D__STDC_FORMAT_MACROS -std=c++14")
 
 # We support three build types:
 # DEBUG: suitable for debugging rr
@@ -97,7 +99,7 @@
 set(RR_FLAGS_DEBUG "-Wall -Wextra -DDEBUG -UNDEBUG")
 set(RR_FLAGS_RELEASE "-Wall -Wextra -UDEBUG -DNDEBUG")
 
-# The folowing settings are the defaults for the OTHER build type.
+# The following settings are the defaults for the OTHER build type.
 # Flags used to build the preload library. MUST have debuginfo enabled. SHOULD be optimized.
 set(PRELOAD_COMPILE_FLAGS "${RR_FLAGS_RELEASE} -fno-stack-protector -g3 -U_FORTIFY_SOURCE")
 # Flags used to build Brotli. SHOULD be optimized. MUST NOT error on warnings.
@@ -132,7 +134,11 @@
 if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-command-line-argument")
 endif()
-if (CMAKE_ASM_COMPILER_ID STREQUAL "Clang")
+# -fno-integrated-as tells Clang to use whatever "as" happens to be. For an
+# Android build that will end up being whatever /usr/bin/as is, and whatever it
+# is, it's the wrong assembler for Android, because Android only supports the
+# Clang assembler.
+if (CMAKE_ASM_COMPILER_ID STREQUAL "Clang" AND NOT ANDROID)
   set(CMAKE_ASM_FLAGS "${CMAKE_ASM_FLAGS} -fno-integrated-as")
 endif()
 
@@ -229,7 +235,12 @@
 
 # ==== brotli ====
 set(BROTLI_FILES
+  third-party/brotli/common/constants.c
+  third-party/brotli/common/context.c
   third-party/brotli/common/dictionary.c
+  third-party/brotli/common/platform.c
+  third-party/brotli/common/shared_dictionary_internal.h
+  third-party/brotli/common/shared_dictionary.c
   third-party/brotli/common/transform.c
   third-party/brotli/dec/bit_reader.c
   third-party/brotli/dec/decode.c
@@ -249,15 +260,17 @@
   third-party/brotli/enc/block_splitter_inc.h
   third-party/brotli/enc/brotli_bit_stream.c
   third-party/brotli/enc/brotli_bit_stream.h
+  third-party/brotli/enc/command.c
   third-party/brotli/enc/cluster.c
   third-party/brotli/enc/cluster.h
   third-party/brotli/enc/cluster_inc.h
   third-party/brotli/enc/command.h
   third-party/brotli/enc/compress_fragment.c
   third-party/brotli/enc/compress_fragment.h
+  third-party/brotli/enc/compound_dictionary.c
+  third-party/brotli/enc/compound_dictionary.h
   third-party/brotli/enc/compress_fragment_two_pass.c
   third-party/brotli/enc/compress_fragment_two_pass.h
-  third-party/brotli/enc/context.h
   third-party/brotli/enc/dictionary_hash.c
   third-party/brotli/enc/dictionary_hash.h
   third-party/brotli/enc/encode.c
@@ -265,6 +278,7 @@
   third-party/brotli/enc/entropy_encode.c
   third-party/brotli/enc/entropy_encode.h
   third-party/brotli/enc/entropy_encode_static.h
+  third-party/brotli/enc/fast_log.c
   third-party/brotli/enc/fast_log.h
   third-party/brotli/enc/find_match_length.h
   third-party/brotli/enc/hash_forgetful_chain_inc.h
@@ -283,28 +297,10 @@
   third-party/brotli/enc/metablock.c
   third-party/brotli/enc/metablock.h
   third-party/brotli/enc/metablock_inc.h
-  third-party/brotli/enc/port.h
   third-party/brotli/enc/prefix.h
   third-party/brotli/enc/quality.h
   third-party/brotli/enc/ringbuffer.h
+  third-party/brotli/enc/state.h
   third-party/brotli/enc/static_dict.c
   third-party/brotli/enc/static_dict.h
   third-party/brotli/enc/static_dict_lut.h
-  third-party/brotli/enc/utf8_util.c
-  third-party/brotli/enc/utf8_util.h
-  third-party/brotli/enc/write_bits.h
-)
-add_library(brotli STATIC ${BROTLI_FILES})
-set_source_files_properties(${BROTLI_FILES}
-                            PROPERTIES COMPILE_FLAGS ${BROTLI_COMPILE_FLAGS})
-# ==== brotli ====
-
-find_library(LIBRT rt)
-
-find_path(SECCOMP NAMES "linux/seccomp.h")
-if(NOT SECCOMP)
-  message(FATAL_ERROR "Couldn't find linux/seccomp.h. You may need to upgrade your kernel.")
-endif()
-
-find_path(EXECINFO_H NAMES "execinfo.h")
-if(EXECINFO_H)

=== debian/changelog ===
rr (5.7.0-2ubuntu0.24.04.1) noble; urgency=medium

  * debian/patches: Add support for AMD Phoenix Zen 4 CPU (LP: #2065141)

 -- Marco Trevisan (Treviño) <marco@ubuntu.com>  Wed, 08 May 2024 09:02:10 +0200

rr (5.7.0-2build1) noble; urgency=medium

  * Rebuild against new libcapnp-1.0.1.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 27 Oct 2023 12:31:29 +0200

rr (5.7.0-2) unstable; urgency=medium

  * Build with Debian’s brotli package.
  * Add test setup to account for the moved stubs.
  * Drop obsolete Lintian spelling overrides.
  * Use C.UTF-8 for tests on Debian, it’s always available, unlike
    en_US.UTF-8.

 -- Stephen Kitt <skitt@debian.org>  Mon, 16 Oct 2023 21:27:45 +0200

rr (5.7.0-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Sat, 07 Oct 2023 20:53:52 +0200

=== debian/control ===
--- 
+++ 
@@ -9,6 +9,7 @@
                dh-python,
                g++-multilib [amd64],
                gdb,
+               libbrotli-dev,
                libcapnp-dev,
                libdisasm-dev,
                libpfm4-dev,

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DH_OPTIONS += -O-Bbuild

include /usr/share/dpkg/architecture.mk

%:
	dh $@ --buildsystem=cmake --with=python3

execute_before_dh_auto_test:
# Ensure the stub is available where rr expects it
	cp build/bin/rr_exec_stub* build/lib/rr

override_dh_auto_test:
# Tests are disabled since they only work on supported CPUs
# (Intel CPUs from Nehalem onwards)

override_dh_auto_install:
	dh_auto_install
	mv debian/rr/usr/bin/signal-rr-recording.sh debian/rr/usr/bin/signal-rr-recording
	mv debian/rr/usr/bin/rr-collect-symbols.py debian/rr/usr/bin/rr-collect-symbols
	mkdir -p debian/rr/usr/lib/rr
	mv debian/rr/usr/bin/rr_* debian/rr/usr/lib/rr/
	mv debian/rr/usr/lib/$(DEB_HOST_MULTIARCH)/rr/lib*.so debian/rr/usr/lib/rr/
	rm -rf debian/rr/usr/lib/$(DEB_HOST_MULTIARCH)
	chmod 644 debian/rr/usr/share/bash-completion/completions/rr

override_dh_strip:
	dh_strip -Xlibrr

override_dh_dwz:
	dh_dwz --no-dwz-multifile

override_dh_python3:
	dh_python3 --no-ext-rename

override_dh_makeshlibs:
	dh_makeshlibs -n

## rr 5.8.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -12,6 +12,12 @@
   cmake_policy(SET CMP0065 NEW)
 endif()
 
+# We should switch to using FindPython3, but that requires CMake 3.12.
+# We'll switch later.
+if(POLICY CMP0148)
+  cmake_policy(SET CMP0148 OLD)
+endif()
+
 # On single configuration generators, make Debug the default configuration
 if(NOT CMAKE_CONFIGURATION_TYPES)
   if(NOT CMAKE_BUILD_TYPE)
@@ -34,7 +40,7 @@
 # debian is happy with it.  However, "_" is illegal in debs, while RPM
 # is cool with it.  Sigh.
 set(rr_VERSION_MAJOR 5)
-set(rr_VERSION_MINOR 7)
+set(rr_VERSION_MINOR 8)
 set(rr_VERSION_PATCH 0)
 
 if(ANDROID)
@@ -68,12 +74,14 @@
   set(FLAGS_COMMON "${FLAGS_COMMON} -march=armv8.3-a -moutline-atomics")
   set(PRELOAD_LIBRARY_PAGE_SIZE 65536)
   set(VDSO_NAME "LINUX_2.6.39")
+  set(VDSO_SYMBOLS "__kernel_clock_getres; __kernel_rt_sigreturn; __kernel_gettimeofday; __kernel_clock_gettime;")
 else()
   set(x86ish true)
   set(has_syscallbuf true)
   set(FLAGS_COMMON "${FLAGS_COMMON} -msse2 -D__MMX__ -D__SSE__ -D__SSE2__")
   set(PRELOAD_LIBRARY_PAGE_SIZE 4096)
   set(VDSO_NAME "LINUX_2.6")
+  set(VDSO_SYMBOLS "__vdso_gettimeofday; __vdso_clock_getres; __vdso_time; __vdso_clock_gettime; __vdso_getcpu;")
 endif()
 configure_file(src/preload/rr_page.ld.in src/preload/rr_page.ld @ONLY)
 
@@ -293,14 +301,3 @@
   third-party/brotli/enc/literal_cost.c
   third-party/brotli/enc/literal_cost.h
   third-party/brotli/enc/memory.c
-  third-party/brotli/enc/memory.h
-  third-party/brotli/enc/metablock.c
-  third-party/brotli/enc/metablock.h
-  third-party/brotli/enc/metablock_inc.h
-  third-party/brotli/enc/prefix.h
-  third-party/brotli/enc/quality.h
-  third-party/brotli/enc/ringbuffer.h
-  third-party/brotli/enc/state.h
-  third-party/brotli/enc/static_dict.c
-  third-party/brotli/enc/static_dict.h
-  third-party/brotli/enc/static_dict_lut.h

=== debian/changelog ===
rr (5.8.0-1) unstable; urgency=medium

  * New upstream release. Closes: #1071515.
  * Build-depend on pkgconf instead of pkg-config.
  * Standards-Version 4.7.0, no change required.

 -- Stephen Kitt <skitt@debian.org>  Mon, 20 May 2024 17:35:13 +0200

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: rr
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Stephen Kitt <skitt@debian.org>
+Maintainer: Stephen Kitt <skitt@debian.org>
 Section: devel
 Priority: optional
 Build-Depends: capnproto,
@@ -13,13 +12,13 @@
                libcapnp-dev,
                libdisasm-dev,
                libpfm4-dev,
-               pkg-config,
+               pkgconf,
                python3,
                python3-pexpect,
                zlib1g-dev,
 # The following are required for the test suite
 # realpath
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/debian/rr
 Vcs-Git: https://salsa.debian.org/debian/rr.git
 Homepage: https://rr-project.org

## rr 5.9.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,6 +25,15 @@
   endif()
 endif()
 
+option(INSTALL_TESTSUITE "Install the testsuite")
+option(force32bit "Force a 32-bit rr build, rather than both 64 and 32-bit. rr will only be able to record and replay 32-bit processes.")
+option(disable32bit "On a 64-bit platform, avoid requiring a 32-bit cross-compilation toolchain by not building 32-bit components. rr will be able to record 32-bit processes but not replay them.")
+option(staticlibs "Force usage of static linkage for non-standard libraries like capnproto")
+option(bpf "Enable bpf acceleration")
+option(asan "Build with address sanitizer enabled.")
+option(intel_pt_decoding "Build with Intel PT decoding enabled.")
+option(strip "Strip debug info from rr binary")
+
 enable_testing()
 set(BUILD_SHARED_LIBS ON)
 
@@ -34,13 +43,12 @@
 
 set(BUILD_TESTS ON CACHE BOOL "Build tests")
 set(WILL_RUN_TESTS ${BUILD_TESTS} CACHE BOOL "Run tests")
-option(INSTALL_TESTSUITE "Install the testsuite")
 
 # CAREFUL!  "-" is an invalid character in RPM package names, while
 # debian is happy with it.  However, "_" is illegal in debs, while RPM
 # is cool with it.  Sigh.
 set(rr_VERSION_MAJOR 5)
-set(rr_VERSION_MINOR 8)
+set(rr_VERSION_MINOR 9)
 set(rr_VERSION_PATCH 0)
 
 if(ANDROID)
@@ -75,13 +83,15 @@
   set(PRELOAD_LIBRARY_PAGE_SIZE 65536)
   set(VDSO_NAME "LINUX_2.6.39")
   set(VDSO_SYMBOLS "__kernel_clock_getres; __kernel_rt_sigreturn; __kernel_gettimeofday; __kernel_clock_gettime;")
-else()
+elseif(${CMAKE_SYSTEM_PROCESSOR} MATCHES i386|i686|x86|x86_64)
   set(x86ish true)
   set(has_syscallbuf true)
   set(FLAGS_COMMON "${FLAGS_COMMON} -msse2 -D__MMX__ -D__SSE__ -D__SSE2__")
   set(PRELOAD_LIBRARY_PAGE_SIZE 4096)
   set(VDSO_NAME "LINUX_2.6")
-  set(VDSO_SYMBOLS "__vdso_gettimeofday; __vdso_clock_getres; __vdso_time; __vdso_clock_gettime; __vdso_getcpu;")
+  set(VDSO_SYMBOLS "gettimeofday; clock_gettime; __vdso_gettimeofday; __vdso_clock_getres; __vdso_time; __vdso_clock_gettime; __vdso_getcpu;")
+else()
+  message(FATAL_ERROR "The architecture " ${CMAKE_SYSTEM_PROCESSOR} " is not yet supported")
 endif()
 configure_file(src/preload/rr_page.ld.in src/preload/rr_page.ld @ONLY)
 
@@ -94,7 +104,7 @@
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${FLAGS_COMMON} -Wstrict-prototypes -std=gnu11")
 # Define __STDC_LIMIT_MACROS so |#include <stdint.h>| works as expected.
 # Define __STDC_FORMAT_MACROS so |#include <inttypes.h>| works as expected.
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${FLAGS_COMMON} -D__STDC_LIMIT_MACROS -D__STDC_FORMAT_MACROS -std=c++14")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${FLAGS_COMMON} -D__STDC_LIMIT_MACROS -D__STDC_FORMAT_MACROS -std=c++17")
 
 # We support three build types:
 # DEBUG: suitable for debugging rr
@@ -109,7 +119,9 @@
 
 # The following settings are the defaults for the OTHER build type.
 # Flags used to build the preload library. MUST have debuginfo enabled. SHOULD be optimized.
-set(PRELOAD_COMPILE_FLAGS "${RR_FLAGS_RELEASE} -fno-stack-protector -g3 -U_FORTIFY_SOURCE")
+# LTO breaks us by moving code around.
+set(PRELOAD_COMPILE_FLAGS "${RR_FLAGS_RELEASE} -fno-stack-protector -g3 -U_FORTIFY_SOURCE -fno-lto")
+set(PRELOAD_LINK_FLAGS "-nostartfiles -fno-lto")
 # Flags used to build Brotli. SHOULD be optimized. MUST NOT error on warnings.
 set(BROTLI_COMPILE_FLAGS ${RR_FLAGS_RELEASE})
 # Flags used to build tests. MUST have -DDEBUG and debuginfo enabled, MUST NOT be optimized.
@@ -149,9 +161,6 @@
 if (CMAKE_ASM_COMPILER_ID STREQUAL "Clang" AND NOT ANDROID)
   set(CMAKE_ASM_FLAGS "${CMAKE_ASM_FLAGS} -fno-integrated-as")
 endif()
-
-option(force32bit "Force a 32-bit rr build, rather than both 64 and 32-bit. rr will only be able to record and replay 32-bit processes.")
-option(disable32bit "On a 64-bit platform, avoid requiring a 32-bit cross-compilation toolchain by not building 32-bit components. rr will be able to record 32-bit processes but not replay them.")
 
 if(force32bit)
   set(rr_32BIT true)
@@ -171,8 +180,6 @@
   endif()
   set(rr_MBITNESS_OPTION)
 endif()
-
-option(staticlibs "Force usage of static linkage for non-standard libraries like capnproto")
 
 # Check that compiling 32-bit code on a 64-bit target works, if required.
 if(CMAKE_HOST_SYSTEM_PROCESSOR STREQUAL "x86_64" AND rr_32BIT)
@@ -224,6 +231,24 @@
 # zlib is required to handle ELF compression
   zlib
 )
+
+if(NOT ANDROID)
+  set(REQUIRED_LIBS
+    ${REQUIRED_LIBS}
+    # zstd is required to handle ELF compression, but isn't available on Android.
+    libzstd
+  )
+  set(ZSTD 1)
+  add_definitions(-DZSTD=1)
+endif()
+
+if(bpf)
+  add_definitions(-DBPF=1)
+  set(REQUIRED_LIBS
+    ${REQUIRED_LIBS}
+    libbpf
+  )
+endif(bpf)
 
 foreach(required_lib ${REQUIRED_LIBS})
   string(TOUPPER ${required_lib} PKG)
@@ -283,21 +308,3 @@
   third-party/brotli/enc/dictionary_hash.h
   third-party/brotli/enc/encode.c
   third-party/brotli/enc/encoder_dict.c
-  third-party/brotli/enc/entropy_encode.c
-  third-party/brotli/enc/entropy_encode.h
-  third-party/brotli/enc/entropy_encode_static.h
-  third-party/brotli/enc/fast_log.c
-  third-party/brotli/enc/fast_log.h
-  third-party/brotli/enc/find_match_length.h
-  third-party/brotli/enc/hash_forgetful_chain_inc.h
-  third-party/brotli/enc/hash.h
-  third-party/brotli/enc/hash_longest_match64_inc.h
-  third-party/brotli/enc/hash_longest_match_inc.h
-  third-party/brotli/enc/hash_longest_match_quickly_inc.h
-  third-party/brotli/enc/hash_to_binary_tree_inc.h
-  third-party/brotli/enc/histogram.c
-  third-party/brotli/enc/histogram.h
-  third-party/brotli/enc/histogram_inc.h
-  third-party/brotli/enc/literal_cost.c
-  third-party/brotli/enc/literal_cost.h
-  third-party/brotli/enc/memory.c

=== third-party/zen-pmu-workaround/Makefile ===
obj-m = zen_workaround.o

all:
	make -C /lib/modules/$(shell uname -r)/build M=$(PWD) modules

clean:
	make -C /lib/modules/$(shell uname -r)/build M=$(PWD) clean

=== debian/changelog ===
rr (5.9.0-6) unstable; urgency=medium

  * Install the rr helper binaries in /usr/libexec/rr instead of
    /usr/lib/rr.
  * Fix zsh completions permissions.
  * Avoid redefining struct open_how. Closes: #1128848.
  * Drop “Priority: optional” since it’s now the default.
  * Standards-Version 4.7.3, no further change required.

 -- Stephen Kitt <skitt@debian.org>  Mon, 23 Feb 2026 19:29:55 +0100

rr (5.9.0-5) unstable; urgency=medium

  * Add another upstream patch required to build without termio.

 -- Stephen Kitt <skitt@debian.org>  Sat, 06 Dec 2025 18:13:36 +0100

rr (5.9.0-4) unstable; urgency=medium

  * Provide a definition of termio to allow building with glibc 2.42,
    which dropped it. Closes: #1115210.
  * Remove the old FSF address from debian/copyright.
  * Drop “Rules-Requires-Root: no” since it’s now the default.

 -- Stephen Kitt <skitt@debian.org>  Sat, 06 Dec 2025 09:47:45 +0100

rr (5.9.0-3) unstable; urgency=medium

  * Disable BPF, it’s not ready for general consumption; see
    https://github.com/rr-debugger/rr/issues/3938 for details.

 -- Stephen Kitt <skitt@debian.org>  Wed, 26 Mar 2025 20:11:56 +0100

rr (5.9.0-2) unstable; urgency=medium

  * Only enable BPF on amd64, it fails to build on other architectures.

 -- Stephen Kitt <skitt@debian.org>  Sat, 01 Mar 2025 23:09:35 +0100

rr (5.9.0-1) unstable; urgency=medium

  * New upstream release.
  * Enable BPF support.
  * Standards-Version 4.7.2, no change required.

 -- Stephen Kitt <skitt@debian.org>  Sat, 01 Mar 2025 15:10:40 +0100

rr (5.8.0-2) unstable; urgency=medium

  * Disable pointer authentication to avoid crashing in initialization
    code on pre-v8.3-A CPUs. Thanks to Emanuele Rocca for the tip!
    Closes: #1078916.

 -- Stephen Kitt <skitt@debian.org>  Wed, 21 Aug 2024 09:09:43 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,6 @@
 Source: rr
 Maintainer: Stephen Kitt <skitt@debian.org>
 Section: devel
-Priority: optional
 Build-Depends: capnproto,
                cmake,
                debhelper-compat (= 13),
@@ -12,17 +11,18 @@
                libcapnp-dev,
                libdisasm-dev,
                libpfm4-dev,
+               libzstd-dev,
+               lldb,
                pkgconf,
                python3,
                python3-pexpect,
                zlib1g-dev,
 # The following are required for the test suite
 # realpath
-Standards-Version: 4.7.0
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/debian/rr
 Vcs-Git: https://salsa.debian.org/debian/rr.git
 Homepage: https://rr-project.org
-Rules-Requires-Root: no
 
 Package: rr
 Architecture: amd64 arm64 i386

=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,7 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-branch
 
 export DH_OPTIONS += -O-Bbuild
 
@@ -25,11 +25,11 @@
 	dh_auto_install
 	mv debian/rr/usr/bin/signal-rr-recording.sh debian/rr/usr/bin/signal-rr-recording
 	mv debian/rr/usr/bin/rr-collect-symbols.py debian/rr/usr/bin/rr-collect-symbols
-	mkdir -p debian/rr/usr/lib/rr
-	mv debian/rr/usr/bin/rr_* debian/rr/usr/lib/rr/
+	mkdir -p debian/rr/usr/lib/rr debian/rr/usr/libexec/rr
+	mv debian/rr/usr/bin/rr_* debian/rr/usr/libexec/rr/
 	mv debian/rr/usr/lib/$(DEB_HOST_MULTIARCH)/rr/lib*.so debian/rr/usr/lib/rr/
 	rm -rf debian/rr/usr/lib/$(DEB_HOST_MULTIARCH)
-	chmod 644 debian/rr/usr/share/bash-completion/completions/rr
+	chmod 644 debian/rr/usr/share/bash-completion/completions/rr debian/rr/usr/share/zsh/site-functions/_rr
 
 override_dh_strip:
 	dh_strip -Xlibrr
